<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <style>
        ul {
            list-style: none;
        }
    </style>
</head>
<body>
    <h1>Word Freqs</h1>
    <ul>
        <script>
            let kingRichardIII = `
                KING RICHARD. A horse! a horse! my kingdom for a horse!
                CATESBY. Withdraw, my lord! I'll help you to a horse.
                KING RICHARD. Slave, I have set my life upon a cast
                    And I Will stand the hazard of the die.
                    I think there be six Richmonds in the field;
                    Five have I slain to-day instead of him.
                    A horse! a horse! my kingdom for a horse!
                From "Richard III", where he is about to loose on 
                the battlefield at Bosworth Field (Aug 22, 1485).
            `;

            function mostFrequent(data, maxWords = 10, minSize = 4) {
                let freqs = data
                        .split(/[^a-zA-Z]+/)
                        .filter(w => w.length >= minSize)
                        .map(w => w.toLowerCase())
                        .reduce((f, w) => {
                            f.set(w, 1 + (f.get(w) || 0));
                            return f;
                        }, new Map())
                    ;
                return [...freqs.entries()]
                    .sort((l, r) => r[1] - l[1])
                    .slice(0, maxWords)
                    ;
            }

            mostFrequent(kingRichardIII).forEach(p => {
                let word = p[0];
                let freq = p[1];
                document.write(`<li>${word}: ${freq}</li>`);
            });
        </script>
    </ul>
</body>
</html>